def fn check_move_is_possible%(row%,col%,direction%,piece$)
rem checks whether a move to this square is possible.
rem returns 1 if move is possible, else 0
rem direction = direction of move to this square:
rem   0 = up, 1 = down, 2 = left, 3 = right
local lp%,a$,lp2%,t%,can_move$
  if piece$="*"
    can_move$="* -."
  else
    if piece$ instr "# -":return 0	: rem these pieces can't move
    can_move$=" ."&piece$		 : rem I can move there if row/col is this
  endif
  if not (current_level$(row%,col%) instr can_move$)
    return 0
  endif
  select on direction%
    = 0 				: rem up
      for lp%=1 to current_level%(1)
	a$=current_level$(lp%)
	for lp2%= 1 to current_level%(0)
	  if a$(lp2%)=piece$
	    if lp%=1
	      return 0			: rem can't move up if at top
	    else
	      t%=current_level$(lp%-1,lp2%) instr can_move$
	      if t%=0:return 0
	    endif
	  endif
	end for lp2%
      end for lp%
      return 1
    = 1 				: rem down
      for lp%=1 to current_level%(1)
	a$=current_level$(lp%)
	for lp2%= 1 to current_level%(0)
	  if a$(lp2%)=piece$
	    if lp%=current_level%(1)
	      return 0			: rem can't move down if at bottom
	    else
	      t%=current_level$(lp%+1,lp2%) instr can_move$
	      if t%=0:return 0
	    endif
	  endif
	end for lp2%
      end for lp%
      return 1
    = 2 				: rem left
      for lp%=1 to current_level%(1)
	a$=current_level$(lp%)
	for lp2%= 1 to current_level%(0)
	  if a$(lp2%)=piece$
	    if lp2%=1
	      return 0			: rem can't move down if at bottom
	    else
	      t%=current_level$(lp%,lp2%-1) instr can_move$
	      if t%=0:return 0
	    endif
	  endif
	end for lp2%
      end for lp%
      return 1
    = 3 				: rem right
      for lp%=1 to current_level%(1)
	a$=current_level$(lp%)
	for lp2%= 1 to current_level%(0)
	  if a$(lp2%)=piece$
	    if lp2%=current_level%(0)
	      return 0			: rem can't move down if at bottom
	    else
	      t%=current_level$(lp%,lp2%+1) instr can_move$
	      if t%=0:return 0
	    endif
	  endif
	end for lp2%
      end for lp%
      return 1
  end select
end def check_move_is_possible
:
